#include "global.h"
#include "item.h"
#include "item_use.h"
#include "constants/items.h"
//#include "item_data_constants.h"
#define POCKET_ITEMS		0x01
#define POCKET_POKE_BALLS	0x02
#define POCKET_TM_HM		0x03
#define POCKET_BERRIES		0x04
#define POCKET_KEY_ITEMS	0x05

const u8 gDummyItemDescription[] = _("?????$");
//pokeballs
const u8 gMasterBallItemDescription[] = _("The best BALL that\ncatches a POKéMON\nwithout fail.$");
const u8 gUltraBallItemDescription[] = _("A better BALL with\na higher catch rate\nthan a GREAT BALL.$");
const u8 gGreatBallItemDescription[] = _("A good BALL with a\nhigher catch rate\nthan a POKé BALL.$");
const u8 gPokeBallItemDescription[] = _("A tool used for\ncatching wild\nPOKéMON.$");
const u8 gSafariBallItemDescription[] = _("A special BALL that\nis used only in the\nSAFARI ZONE.$");
const u8 gNetBallItemDescription[] = _("A BALL that works\nwell on WATER- and\nBUG-type POKéMON.$");
const u8 gDiveBallItemDescription[] = _("A BALL that works\nbetter on POKéMON\non the ocean floor.$");
const u8 gNestBallItemDescription[] = _("A BALL that works\nbetter on weaker\nPOKéMON.$");
const u8 gRepeatBallItemDescription[] = _("A BALL that works\nbetter on POKéMON\ncaught before.$");
const u8 gTimerBallItemDescription[] = _("A BALL that gains\npower in battles\ntaking many turns.$");
const u8 gLuxuryBallItemDescription[] = _("A cozy BALL that\nmakes POKéMON\nmore friendly.$");
const u8 gPremierBallItemDescription[] = _("A rare BALL made\nin commemoration\nof some event.$");
//medicine
const u8 gPotionItemDescription[] = _("Restores the HP of\na POKéMON by\n20 points.$");
const u8 gAntidoteItemDescription[] = _("Heals a poisoned\nPOKéMON.$");
const u8 gBurnHealItemDescription[] = _("Heals POKéMON\nof a burn.$");
const u8 gIceHealItemDescription[] = _("Defrosts a frozen\nPOKéMON.$");
const u8 gAwakeningItemDescription[] = _("Awakens a sleeping\nPOKéMON.$");
const u8 gParalyzeHealItemDescription[] = _("Heals a paralyzed\nPOKéMON.$");
const u8 gFullRestoreItemDescription[] = _("Fully restores the\nHP and status of a\nPOKéMON.$");
const u8 gMaxPotionItemDescription[] = _("Fully restores the\nHP of a POKéMON.$");
const u8 gHyperPotionItemDescription[] = _("Restores the HP of\na POKéMON by\n200 points.$");
const u8 gSuperPotionItemDescription[] = _("Restores the HP of\na POKéMON by\n50 points.$");
const u8 gFullHealItemDescription[] = _("Heals all the\nstatus problems of\none POKéMON.$");
const u8 gReviveItemDescription[] = _("Revives a fainted\nPOKéMON with half\nits HP.$");
const u8 gMaxReviveItemDescription[] = _("Revives a fainted\nPOKéMON with all\nits HP.$");
const u8 gFreshWaterItemDescription[] = _("A mineral water\nthat restores HP\nby 50 points.$");
const u8 gSodaPopItemDescription[] = _("A fizzy soda drink\nthat restores HP\nby 60 points.$");
const u8 gLemonadeItemDescription[] = _("A very sweet drink\nthat restores HP\nby 80 points.$");
const u8 gMoomooMilkItemDescription[] = _("A nutritious milk\nthat restores HP\nby 100 points.$");
const u8 gEnergyPowderItemDescription[] = _("A bitter powder\nthat restores HP\nby 50 points.$");
const u8 gEnergyRootItemDescription[] = _("A bitter root\nthat restores HP\nby 200 points.$");
const u8 gHealPowderItemDescription[] = _("A bitter powder\nthat heals all\nstatus problems.$");
const u8 gRevivalHerbItemDescription[] = _("A very bitter herb\nthat revives a\nfainted POKéMON.$");
const u8 gEtherItemDescription[] = _("Restores the PP\nof a selected move\nby 10.$");
const u8 gMaxEtherItemDescription[] = _("Fully restores the\nPP of a selected\nmove.$");
const u8 gElixirItemDescription[] = _("Restores the PP\nof all moves by 10.$");
const u8 gMaxElixirItemDescription[] = _("Fully restores the\nPP of a POKéMON’s\nmoves.$");
const u8 gLavaCookieItemDescription[] = _("A local specialty\nthat heals all\nstatus problems.$");
const u8 gBlueFluteItemDescription[] = _("A glass flute that\nawakens sleeping\nPOKéMON.$");
const u8 gYellowFluteItemDescription[] = _("A glass flute that\nsnaps POKéMON\nout of confusion.$");
const u8 gRedFluteItemDescription[] = _("A glass flute that\nsnaps POKéMON\nout of attraction.$");
const u8 gBlackFluteItemDescription[] = _("A glass flute that\nkeeps away wild\nPOKéMON.$");
const u8 gWhiteFluteItemDescription[] = _("A glass flute that\nlures wild POKéMON.$");
const u8 gBerryJuiceItemDescription[] = _("A 100% pure juice\nthat restores HP\nby 20 points.$");
const u8 gSacredAshItemDescription[] = _("Fully revives and\nrestores all\nfainted POKéMON.$");
//collectibles
const u8 gShoalSaltItemDescription[] = _("Salt obtained from\ndeep inside the\nSHOAL CAVE.$");
const u8 gShoalShellItemDescription[] = _("A seashell found\ndeep inside the\nSHOAL CAVE.$");
const u8 gRedShardItemDescription[] = _("A shard from an\nancient item. Can\nbe sold cheaply.$");
const u8 gBlueShardItemDescription[] = _("A shard from an\nancient item. Can\nbe sold cheaply.$");
const u8 gYellowShardItemDescription[] = _("A shard from an\nancient item. Can\nbe sold cheaply.$");
const u8 gGreenShardItemDescription[] = _("A shard from an\nancient item. Can\nbe sold cheaply.$");
//vitamins
const u8 gHPUpItemDescription[] = _("Raises the base HP\nof one POKéMON.$");
const u8 gProteinItemDescription[] = _("Raises the base\nATTACK stat of one\nPOKéMON.$");
const u8 gIronItemDescription[] = _("Raises the base\nDEFENSE stat of\none POKéMON.$");
const u8 gCarbosItemDescription[] = _("Raises the base\nSPEED stat of one\nPOKéMON.$");
const u8 gCalciumItemDescription[] = _("Raises the base\nSP. ATK stat of one\nPOKéMON.$");
const u8 gRareCandyItemDescription[] = _("Raises the level\nof a POKéMON by\none.$");
const u8 gPPUpItemDescription[] = _("Raises the maximum\nPP of a selected\nmove.$");
const u8 gZincItemDescription[] = _("Raises the base\nSP. DEF stat of one\nPOKéMON.$");
const u8 gPPMaxItemDescription[] = _("Raises the PP of a\nmove to its maximum\npoints.$");
//battle items
const u8 gGuardSpecItemDescription[] = _("Prevents stat\nreduction when\nused in battle.$");
const u8 gDireHitItemDescription[] = _("Raises the\ncritical-hit ratio\nduring one battle.$");
const u8 gXAttackItemDescription[] = _("Raises the stat\nATTACK during one\nbattle.$");
const u8 gXDefendItemDescription[] = _("Raises the stat\nDEFENSE during one\nbattle.$");
const u8 gXSpeedItemDescription[] = _("Raises the stat\nSPEED during one\nbattle.$");
const u8 gXAccuracyItemDescription[] = _("Raises accuracy\nof attack moves\nduring one battle.$");
const u8 gXSpecialItemDescription[] = _("Raises the stat\nSP. ATK during one\nbattle.$");
const u8 gPokeDollItemDescription[] = _("Use to flee from\nany battle with\na wild POKéMON.$");
const u8 gFluffyTailItemDescription[] = _("Use to flee from\nany battle with\na wild POKéMON.$");
//field items
const u8 gSuperRepelItemDescription[] = _("Repels weak wild\nPOKéMON for 200\nsteps.$");
const u8 gMaxRepelItemDescription[] = _("Repels weak wild\nPOKéMON for 250\nsteps.$");
const u8 gEscapeRopeItemDescription[] = _("Use to escape\ninstantly from a\ncave or a dungeon.$");
const u8 gRepelItemDescription[] = _("Repels weak wild\nPOKéMON for 100\nsteps.$");
//evolution stones
const u8 gSunStoneItemDescription[] = _("Makes certain\nspecies of POKéMON\nevolve.$");
const u8 gMoonStoneItemDescription[] = _("Makes certain\nspecies of POKéMON\nevolve.$");
const u8 gFireStoneItemDescription[] = _("Makes certain\nspecies of POKéMON\nevolve.$");
const u8 gThunderStoneItemDescription[] = _("Makes certain\nspecies of POKéMON\nevolve.$");
const u8 gWaterStoneItemDescription[] = _("Makes certain\nspecies of POKéMON\nevolve.$");
const u8 gLeafStoneItemDescription[] = _("Makes certain\nspecies of POKéMON\nevolve.$");
//valuable items
const u8 gTinyMushroomItemDescription[] = _("A plain mushroom\nthat would sell\nat a cheap price.$");
const u8 gBigMushroomItemDescription[] = _("A rare mushroom\nthat would sell at a\nhigh price.$");
const u8 gPearlItemDescription[] = _("A pretty pearl\nthat would sell at a\ncheap price.$");
const u8 gBigPearlItemDescription[] = _("A lovely large pearl\nthat would sell at a\nhigh price.$");
const u8 gStardustItemDescription[] = _("Beautiful red sand.\nCan be sold at a\nhigh price.$");
const u8 gStarPieceItemDescription[] = _("A red gem shard.\nIt would sell for a\nvery high price.$");
const u8 gNuggetItemDescription[] = _("A nugget of pure\ngold. Can be sold at\na high price.$");
const u8 gHeartScaleItemDescription[] = _("A lovely scale.\nIt is coveted by\ncollectors.$");
//mail
const u8 gOrangeMailItemDescription[] = _("A ZIGZAGOON-print\nMAIL to be held by\na POKéMON.$");
const u8 gHarborMailItemDescription[] = _("A WINGULL-print\nMAIL to be held by\na POKéMON.$");
const u8 gGlitterMailItemDescription[] = _("A PIKACHU-print\nMAIL to be held by\na POKéMON.$");
const u8 gMechMailItemDescription[] = _("A MAGNEMITE-print\nMAIL to be held by\na POKéMON.$");
const u8 gWoodMailItemDescription[] = _("A SLAKOTH-print\nMAIL to be held by\na POKéMON.$");
const u8 gWaveMailItemDescription[] = _("A WAILMER-print\nMAIL to be held by\na POKéMON.$");
const u8 gBeadMailItemDescription[] = _("MAIL featuring a\nsketch of the\nholding POKéMON.$");
const u8 gShadowMailItemDescription[] = _("A DUSKULL-print\nMAIL to be held by\na POKéMON.$");
const u8 gTropicMailItemDescription[] = _("A BELLOSSOM-print\nMAIL to be held by\na POKéMON.$");
const u8 gDreamMailItemDescription[] = _("MAIL featuring a\nsketch of the\nholding POKéMON.$");
const u8 gFabMailItemDescription[] = _("A gorgeous-print\nMAIL to be held\nby a POKéMON.$");
const u8 gRetroMailItemDescription[] = _("MAIL featuring the\ndrawings of three\nPOKéMON.$");
//berries
const u8 gCheriBerryItemDescription[] = _("A hold item that\nheals paralysis\nin battle.$");
const u8 gChestoBerryItemDescription[] = _("A hold item that\nawakens POKéMON\nin battle.$");
const u8 gPechaBerryItemDescription[] = _("A hold item that\nheals poisoning\nin battle.$");
const u8 gRawstBerryItemDescription[] = _("A hold item that\nheals a burn in\nbattle.$");
const u8 gAspearBerryItemDescription[] = _("A hold item that\ndefrosts POKéMON\nin battle.$");
const u8 gLeppaBerryItemDescription[] = _("A hold item that\nrestores 10 PP in\nbattle.$");
const u8 gOranBerryItemDescription[] = _("A hold item that\nrestores 10 HP in\nbattle.$");
const u8 gPersimBerryItemDescription[] = _("A hold item that\nheals confusion\nin battle.$");
const u8 gLumBerryItemDescription[] = _("A hold item that\nheals any status\nproblem in battle.$");
const u8 gSitrusBerryItemDescription[] = _("A hold item that\nrestores 30 HP in\nbattle.$");
const u8 gFigyBerryItemDescription[] = _("A hold item that\nrestores HP but\nmay confuse.$");
const u8 gWikiBerryItemDescription[] = _("A hold item that\nrestores HP but\nmay confuse.$");
const u8 gMagoBerryItemDescription[] = _("A hold item that\nrestores HP but\nmay confuse.$");
const u8 gAguavBerryItemDescription[] = _("A hold item that\nrestores HP but\nmay confuse.$");
const u8 gIapapaBerryItemDescription[] = _("A hold item that\nrestores HP but\nmay confuse.$");
const u8 gRazzBerryItemDescription[] = _("{POKEBLOCK} ingredient.\nPlant in loamy soil\nto grow RAZZ.$");
const u8 gBlukBerryItemDescription[] = _("{POKEBLOCK} ingredient.\nPlant in loamy soil\nto grow BLUK.$");
const u8 gNanabBerryItemDescription[] = _("{POKEBLOCK} ingredient.\nPlant in loamy soil\nto grow NANAB.$");
const u8 gWepearBerryItemDescription[] = _("{POKEBLOCK} ingredient.\nPlant in loamy soil\nto grow WEPEAR.$");
const u8 gPinapBerryItemDescription[] = _("{POKEBLOCK} ingredient.\nPlant in loamy soil\nto grow PINAP.$");
const u8 gPomegBerryItemDescription[] = _("Makes a POKéMON\nfriendly but lowers\nbase HP.$");
const u8 gKelpsyBerryItemDescription[] = _("Makes a POKéMON\nfriendly but lowers\nbase ATTACK.$");
const u8 gQualotBerryItemDescription[] = _("Makes a POKéMON\nfriendly but lowers\nbase DEFENSE.$");
const u8 gHondewBerryItemDescription[] = _("Makes a POKéMON\nfriendly but lowers\nbase SP. ATK.$");
const u8 gGrepaBerryItemDescription[] = _("Makes a POKéMON\nfriendly but lowers\nbase SP. DEF.$");
const u8 gTamatoBerryItemDescription[] = _("Makes a POKéMON\nfriendly but lowers\nbase SPEED.$");
const u8 gCornnBerryItemDescription[] = _("{POKEBLOCK} ingredient.\nPlant in loamy soil\nto grow CORNN.$");
const u8 gMagostBerryItemDescription[] = _("{POKEBLOCK} ingredient.\nPlant in loamy soil\nto grow MAGOST.$");
const u8 gRabutaBerryItemDescription[] = _("{POKEBLOCK} ingredient.\nPlant in loamy soil\nto grow RABUTA.$");
const u8 gNomelBerryItemDescription[] = _("{POKEBLOCK} ingredient.\nPlant in loamy soil\nto grow NOMEL.$");
const u8 gSpelonBerryItemDescription[] = _("{POKEBLOCK} ingredient.\nPlant in loamy soil\nto grow SPELON.$");
const u8 gPamtreBerryItemDescription[] = _("{POKEBLOCK} ingredient.\nPlant in loamy soil\nto grow PAMTRE.$");
const u8 gWatmelBerryItemDescription[] = _("{POKEBLOCK} ingredient.\nPlant in loamy soil\nto grow WATMEL.$");
const u8 gDurinBerryItemDescription[] = _("{POKEBLOCK} ingredient.\nPlant in loamy soil\nto grow DURIN.$");
const u8 gBelueBerryItemDescription[] = _("{POKEBLOCK} ingredient.\nPlant in loamy soil\nto grow BELUE.$");
const u8 gLiechiBerryItemDescription[] = _("A hold item that\nraises ATTACK in\na pinch.$");
const u8 gGanlonBerryItemDescription[] = _("A hold item that\nraises DEFENSE in\na pinch.$");
const u8 gSalacBerryItemDescription[] = _("A hold item that\nraises SPEED in\na pinch.$");
const u8 gPetayaBerryItemDescription[] = _("A hold item that\nraises SP. ATK in\na pinch.$");
const u8 gApicotBerryItemDescription[] = _("A hold item that\nraises SP. DEF in\na pinch.$");
const u8 gLansatBerryItemDescription[] = _("A hold item that\nups the critical-\nhit rate in a pinch.$");
const u8 gStarfBerryItemDescription[] = _("A hold item that\nsharply boosts a\nstat in a pinch.$");
const u8 gEnigmaBerryItemDescription[] = _("{POKEBLOCK} ingredient.\nPlant in loamy soil\nto grow a mystery.$");
//hold items
const u8 gBrightPowderItemDescription[] = _("A hold item that\ncasts a glare to\nreduce accuracy.$");
const u8 gWhiteHerbItemDescription[] = _("A hold item that\nrestores any\nlowered stat.$");
const u8 gMachoBraceItemDescription[] = _("A hold item that\npromotes growth,\nbut reduces SPEED.$");
const u8 gExpShareItemDescription[] = _("A hold item that\ngets EXP. points\nfrom battles.$");
const u8 gQuickClawItemDescription[] = _("A hold item that\noccasionally allows\nthe first strike.$");
const u8 gSootheBellItemDescription[] = _("A hold item that\ncalms spirits and\nfosters friendship.$");
const u8 gMentalHerbItemDescription[] = _("A hold item that\nsnaps POKéMON out\nof infatuation.$");
const u8 gChoiceBandItemDescription[] = _("Raises a move’s\npower, but permits\nonly that move.$");
const u8 gKingsRockItemDescription[] = _("A hold item that\nmay cause flinching\nwhen the foe is hit.$");
const u8 gSilverPowderItemDescription[] = _("A hold item that\nraises the power of\nBUG-type moves.$");
const u8 gAmuletCoinItemDescription[] = _("Doubles money in\nbattle if the\nholder takes part.$");
const u8 gCleanseTagItemDescription[] = _("A hold item that\nhelps repel wild\nPOKéMON.$");
const u8 gSoulDewItemDescription[] = _("Hold item: raises\nSP. ATK & SP. DEF of\nLATIOS & LATIAS.$");
const u8 gDeepSeaToothItemDescription[] = _("A hold item that\nraises the SP. ATK\nof CLAMPERL.$");
const u8 gDeepSeaScaleItemDescription[] = _("A hold item that\nraises the SP. DEF\nof CLAMPERL.$");
const u8 gSmokeBallItemDescription[] = _("A hold item that\nassures fleeing\nfrom wild POKéMON.$");
const u8 gEverstoneItemDescription[] = _("A wondrous hold\nitem that prevents\nevolution.$");
const u8 gFocusBandItemDescription[] = _("A hold item that\noccasionally\nprevents fainting.$");
const u8 gLuckyEggItemDescription[] = _("A hold item that\nboosts EXP. points\nearned in battle.$");
const u8 gScopeLensItemDescription[] = _("A hold item that\nimproves the\ncritical-hit rate.$");
const u8 gMetalCoatItemDescription[] = _("A hold item that\nraises the power of\nSTEEL-type moves.$");
const u8 gLeftoversItemDescription[] = _("A hold item that\ngradually restores\nHP in battle.$");
const u8 gDragonScaleItemDescription[] = _("A strange scale\nheld by DRAGON-\ntype POKéMON.$");
const u8 gLightBallItemDescription[] = _("A hold item that\nraises the SP. ATK\nof PIKACHU.$");
const u8 gSoftSandItemDescription[] = _("A hold item that\nraises the power of\nGROUND-type moves.$");
const u8 gHardStoneItemDescription[] = _("A hold item that\nraises the power of\nROCK-type moves.$");
const u8 gMiracleSeedItemDescription[] = _("A hold item that\nraises the power of\nGRASS-type moves.$");
const u8 gBlackGlassesItemDescription[] = _("A hold item that\nraises the power of\nDARK-type moves.$");
const u8 gBlackBeltItemDescription[] = _("A hold item that\nboosts FIGHTING-\ntype moves.$");
const u8 gMagnetItemDescription[] = _("A hold item that\nboosts ELECTRIC-\ntype moves.$");
const u8 gMysticWaterItemDescription[] = _("A hold item that\nraises the power of\nWATER-type moves.$");
const u8 gSharpBeakItemDescription[] = _("A hold item that\nraises the power of\nFLYING-type moves.$");
const u8 gPoisonBarbItemDescription[] = _("A hold item that\nraises the power of\nPOISON-type moves.$");
const u8 gNeverMeltIceItemDescription[] = _("A hold item that\nraises the power of\nICE-type moves.$");
const u8 gSpellTagItemDescription[] = _("A hold item that\nraises the power of\nGHOST-type moves.$");
const u8 gTwistedSpoonItemDescription[] = _("A hold item that\nboosts PSYCHIC-\ntype moves.$");
const u8 gCharcoalItemDescription[] = _("A hold item that\nraises the power of\nFIRE-type moves.$");
const u8 gDragonFangItemDescription[] = _("A hold item that\nraises the power of\nDRAGON-type moves.$");
const u8 gSilkScarfItemDescription[] = _("A hold item that\nraises the power of\nNORMAL-type moves.$");
const u8 gUpGradeItemDescription[] = _("A peculiar box made\nby SILPH CO.$");
const u8 gShellBellItemDescription[] = _("A hold item that\nrestores HP upon\nstriking the foe.$");
const u8 gSeaIncenseItemDescription[] = _("A hold item that\nslightly boosts\nWATER-type moves.$");
const u8 gLaxIncenseItemDescription[] = _("A hold item that\nslightly lowers the\nfoe’s accuracy.$");
const u8 gLuckyPunchItemDescription[] = _("A hold item that\nraises CHANSEY’s\ncritical-hit rate.$");
const u8 gMetalPowderItemDescription[] = _("A hold item that\nraises DITTO’s\nDEFENSE.$");
const u8 gThickClubItemDescription[] = _("A hold item that \nraises CUBONE or\nMAROWAK’s ATTACK.$");
const u8 gStickItemDescription[] = _("A hold item that\nraises FARFETCH’D’s\ncritical-hit ratio.$");
const u8 gRedScarfItemDescription[] = _("A hold item that\nraises COOL in\nCONTESTS.$");
const u8 gBlueScarfItemDescription[] = _("A hold item that\nraises BEAUTY in\nCONTESTS.$");
const u8 gPinkScarfItemDescription[] = _("A hold item that\nraises CUTE in\nCONTESTS.$");
const u8 gGreenScarfItemDescription[] = _("A hold item that\nraises SMART in\nCONTESTS.$");
const u8 gYellowScarfItemDescription[] = _("A hold item that\nraises TOUGH in\nCONTESTS.$");
//key items
const u8 gMachBikeItemDescription[] = _("A folding bicycle\nthat doubles your\nspeed or better.$");
const u8 gCoinCaseItemDescription[] = _("A case that holds\nup to 9,999 COINS.$");
const u8 gItemfinderItemDescription[] = _("A device that\nsignals an invisible\nitem by sound.$");
const u8 gOldRodItemDescription[] = _("Use by any body of\nwater to fish for\nwild POKéMON.$");
const u8 gGoodRodItemDescription[] = _("A decent fishing\nrod for catching\nwild POKéMON.$");
const u8 gSuperRodItemDescription[] = _("The best fishing\nrod for catching\nwild POKéMON.$");
const u8 gSSTicketItemDescription[] = _("The ticket required\nfor sailing on a\nferry.$");
const u8 gContestPassItemDescription[] = _("The pass required\nfor entering\nPOKéMON CONTESTS.$");
const u8 gWailmerPailItemDescription[] = _("A tool used for\nwatering BERRIES\nand plants.$");
const u8 gDevonGoodsItemDescription[] = _("A package that\ncontains DEVON’s\nmachine parts.$");
const u8 gSootSackItemDescription[] = _("A sack used to\ngather and hold\nvolcanic ash.$");
const u8 gBasementKeyItemDescription[] = _("The key for NEW\nMAUVILLE beneath\nMAUVILLE CITY.$");
const u8 gAcroBikeItemDescription[] = _("A folding bicycle\ncapable of jumps\nand wheelies.$");
const u8 gPokeblockCaseItemDescription[] = _("A case for holding\n{POKEBLOCK}S made with\na BERRY BLENDER.$");
const u8 gLetterItemDescription[] = _("A letter to STEVEN\nfrom the PRESIDENT\nof the DEVON CORP.$");
const u8 gEonTicketItemDescription[] = _("The ticket for a\nferry to a distant\nsouthern island.$");
const u8 gRedOrbItemDescription[] = _("A red, glowing orb\nsaid to contain an\nancient power.$");
const u8 gBlueOrbItemDescription[] = _("A blue, glowing orb\nsaid to contain an\nancient power.$");
const u8 gScannerItemDescription[] = _("A device found\ninside the\nABANDONED SHIP.$");
const u8 gGoGogglesItemDescription[] = _("Nifty goggles that\nprotect eyes from\ndesert sandstorms.$");
const u8 gMeteoriteItemDescription[] = _("A meteorite found\nat METEOR FALLS.$");
const u8 gRoom1KeyItemDescription[] = _("A key that opens a\ndoor inside the\nABANDONED SHIP.$");
const u8 gRoom2KeyItemDescription[] = _("A key that opens a\ndoor inside the\nABANDONED SHIP.$");
const u8 gRoom4KeyItemDescription[] = _("A key that opens a\ndoor inside the\nABANDONED SHIP.$");
const u8 gRoom6KeyItemDescription[] = _("A key that opens a\ndoor inside the\nABANDONED SHIP.$");
const u8 gStorageKeyItemDescription[] = _("The key to the\nstorage inside the\nABANDONED SHIP.$");
const u8 gRootFossilItemDescription[] = _("A fossil of an\nancient, seafloor-\ndwelling POKéMON.$");
const u8 gClawFossilItemDescription[] = _("A fossil of an\nancient, seafloor-\ndwelling POKéMON.$");
const u8 gDevonScopeItemDescription[] = _("A device by DEVON\nthat signals any\nunseeable POKéMON.$");
//TMs/HMs
const u8 gTM01ItemDescription[] = _("Powerful, but makes\nthe user flinch if\nhit by the foe.$");
const u8 gTM02ItemDescription[] = _("Hooks and slashes\nthe foe with long,\nsharp claws.$");
const u8 gTM03ItemDescription[] = _("Generates an\nultrasonic wave\nthat may confuse.$");
const u8 gTM04ItemDescription[] = _("Raises SP. ATK and\nSP. DEF by focusing\nthe mind.$");
const u8 gTM05ItemDescription[] = _("A savage roar that\nmakes the foe flee \nto end the battle.$");
const u8 gTM06ItemDescription[] = _("Poisons the foe\nwith a toxin that\ngradually worsens.$");
const u8 gTM07ItemDescription[] = _("Creates a hailstorm\nthat damages all\ntypes except ICE.$");
const u8 gTM08ItemDescription[] = _("Bulks up the body\nto boost both\nATTACK & DEFENSE.$");
const u8 gTM09ItemDescription[] = _("Shoots 2 to 5 seeds\nin a row to strike\nthe foe.$");
const u8 gTM10ItemDescription[] = _("The attack power\nvaries among\ndifferent POKéMON.$");
const u8 gTM11ItemDescription[] = _("Raises the power of\nFIRE-type moves\nfor 5 turns.$");
const u8 gTM12ItemDescription[] = _("Enrages the foe so\nit can only use\nattack moves.$");
const u8 gTM13ItemDescription[] = _("Fires an icy cold\nbeam that may\nfreeze the foe.$");
const u8 gTM14ItemDescription[] = _("A brutal snow-and-\nwind attack that\nmay freeze the foe.$");
const u8 gTM15ItemDescription[] = _("Powerful, but needs\nrecharging the\nnext turn.$");
const u8 gTM16ItemDescription[] = _("Creates a wall of\nlight that lowers\nSP. ATK damage.$");
const u8 gTM17ItemDescription[] = _("Negates all damage,\nbut may fail if used\nin succession.$");
const u8 gTM18ItemDescription[] = _("Raises the power of\nWATER-type moves\nfor 5 turns.$");
const u8 gTM19ItemDescription[] = _("Recovers half the\nHP of the damage \nthis move inflicts.$");
const u8 gTM20ItemDescription[] = _("Prevents status\nabnormality with a\nmystical power.$");
const u8 gTM21ItemDescription[] = _("The less the user\nlikes you, the more\npowerful this move.$");
const u8 gTM22ItemDescription[] = _("Absorbs sunlight in\nthe 1st turn, then\nattacks next turn.$");
const u8 gTM23ItemDescription[] = _("Slams the foe with\na hard tail. It may\nlower DEFENSE.$");
const u8 gTM24ItemDescription[] = _("A powerful electric\nattack that may\ncause paralysis.$");
const u8 gTM25ItemDescription[] = _("Strikes the foe\nwith a thunderbolt.\nIt may paralyze.$");
const u8 gTM26ItemDescription[] = _("Causes a quake\nthat has no effect\non flying foes.$");
const u8 gTM27ItemDescription[] = _("The more the user\nlikes you, the more\npowerful this move.$");
const u8 gTM28ItemDescription[] = _("Digs underground\nthe 1st turn, then\nstrikes next turn.$");
const u8 gTM29ItemDescription[] = _("A powerful psychic\nattack that may\nlower SP. DEF.$");
const u8 gTM30ItemDescription[] = _("Hurls a dark lump\nat the foe. It may\nlower SP. DEF.$");
const u8 gTM31ItemDescription[] = _("Destroys barriers\nlike LIGHT SCREEN\nand causes damage.$");
const u8 gTM32ItemDescription[] = _("Creates illusory\ncopies to enhance\nelusiveness.$");
const u8 gTM33ItemDescription[] = _("Creates a wall of\nlight that weakens\nphysical attacks.$");
const u8 gTM34ItemDescription[] = _("Zaps the foe with a\njolt of electricity\nthat never misses.$");
const u8 gTM35ItemDescription[] = _("Looses a stream of\nfire that may burn\nthe foe.$");
const u8 gTM36ItemDescription[] = _("Hurls sludge at the\nfoe. It may poison\nthe foe.$");
const u8 gTM37ItemDescription[] = _("Causes a sandstorm\nthat hits the foe\nover several turns.$");
const u8 gTM38ItemDescription[] = _("A powerful fire\nattack that may\nburn the foe.$");
const u8 gTM39ItemDescription[] = _("Stops the foe from\nmoving with rocks.\nMay lower SPEED.$");
const u8 gTM40ItemDescription[] = _("An extremely fast\nattack that can’t\nbe avoided.$");
const u8 gTM41ItemDescription[] = _("Prevents the foe\nfrom using the same\nmove in a row.$");
const u8 gTM42ItemDescription[] = _("Raises ATTACK when\npoisoned, burned,\nor paralyzed.$");
const u8 gTM43ItemDescription[] = _("Adds an effect to\nattack depending\non the location.$");
const u8 gTM44ItemDescription[] = _("The user sleeps for\n2 turns to restore\nhealth and status.$");
const u8 gTM45ItemDescription[] = _("Makes it tough to\nattack a foe of the\nopposite gender.$");
const u8 gTM46ItemDescription[] = _("While attacking,\nit may steal the\nfoe’s held item.$");
const u8 gTM47ItemDescription[] = _("Spreads hard-\nedged wings and\nslams into the foe.$");
const u8 gTM48ItemDescription[] = _("Switches abilities\nwith the foe on the\nturn this is used.$");
const u8 gTM49ItemDescription[] = _("Steals the effects\nof the move the foe\nis trying to use.$");
const u8 gTM50ItemDescription[] = _("Enables full-power\nattack, but sharply\nlowers SP. ATK.$");

const u8 gHM01ItemDescription[] = _("Attacks the foe\nwith sharp blades\nor claws.$");
const u8 gHM02ItemDescription[] = _("Flies up on the\nfirst turn, then\nattacks next turn.$");
const u8 gHM03ItemDescription[] = _("Creates a huge\nwave, then crashes\nit down on the foe.$");
const u8 gHM04ItemDescription[] = _("Builds enormous\npower, then slams\nthe foe.$");
const u8 gHM05ItemDescription[] = _("Looses a powerful\nblast of light that\nreduces accuracy.$");
const u8 gHM06ItemDescription[] = _("A rock-crushingly\ntough attack that\nmay lower DEFENSE.$");
const u8 gHM07ItemDescription[] = _("Attacks the foe\nwith enough power\nto climb waterfalls.$");
const u8 gHM08ItemDescription[] = _("Dives underwater\nthe 1st turn, then\nattacks next turn.$");
//FireRed/LeafGreen specific key items
const u8 gOaksParcelItemDescription[] = _("A parcel for PROF.\nOAK from a POKéMON\nMART’s clerk.$");
const u8 gPokeFluteItemDescription[] = _("A sweet-sounding\nflute that awakens\nPOKéMON.$");
const u8 gSecretKeyItemDescription[] = _("The key to the\nCINNABAR ISLAND\nGYM’s entrance.$");
const u8 gBikeVoucherItemDescription[] = _("A voucher for\nobtaining a bicycle\nfrom the BIKE SHOP.$");
const u8 gGoldTeethItemDescription[] = _("Gold dentures lost\nby the SAFARI\nZONE’s WARDEN.$");
const u8 gOldAmberItemDescription[] = _("A stone containing\nthe genes of an\nancient POKéMON.$");
const u8 gCardKeyItemDescription[] = _("A card-type door\nkey used in SILPH\nCO’s office.$");
const u8 gLiftKeyItemDescription[] = _("An elevator key\nused in TEAM\nROCKET’s HIDEOUT.$");
const u8 gHelixFossilItemDescription[] = _("A piece of an\nancient marine\nPOKéMON’s seashell.$");
const u8 gDomeFossilItemDescription[] = _("A piece of an\nancient marine\nPOKéMON’s shell.$");
const u8 gSilphScopeItemDescription[] = _("SILPH CO’s scope\nmakes unseeable\nPOKéMON visible.$");
const u8 gBicycleItemDescription[] = _("A folding bicycle\nthat is faster than\nthe RUNNING SHOES.$");
const u8 gTownMapItemDescription[] = _("Can be viewed\nanytime. Shows your\npresent location.$");
const u8 gVSSeekerItemDescription[] = _("A rechargeable unit\nthat flags battle-\nready TRAINERS.$");
const u8 gFameCheckerItemDescription[] = _("Stores information\non famous people\nfor instant recall.$");
const u8 gTMCaseItemDescription[] = _("A convenient case \nthat holds TMs and\nHMs.$");
const u8 gBerryPouchItemDescription[] = _("A convenient\ncontainer that\nholds BERRIES.$");
const u8 gTeachyTVItemDescription[] = _("A TV set tuned to\nan advice program\nfor TRAINERS.$");
const u8 gTriPassItemDescription[] = _("A pass for ferries\nbetween ONE, TWO,\nand THREE ISLAND.$");
const u8 gRainbowPassItemDescription[] = _("For ferries serving\nVERMILION and the\nSEVII ISLANDS.$");
const u8 gTeaItemDescription[] = _("A thirst-quenching\ntea prepared by an\nold lady.$");
const u8 gMysticTicketItemDescription[] = _("A ticket required\nto board the ship\nto NAVEL ROCK.$");
const u8 gAuroraTicketItemDescription[] = _("A ticket required\nto board the ship\nto BIRTH ISLAND.$");
const u8 gPowderJarItemDescription[] = _("Stores BERRY\nPOWDER made using\na BERRY CRUSHER.$");
const u8 gRubyItemDescription[] = _("An exquisite, red-\nglowing gem that\nsymbolizes passion.$");
const u8 gSapphireItemDescription[] = _("A brilliant blue gem\nthat symbolizes\nhonesty.$");
//Emerald specific key items
const u8 gMagmaEmblemItemDescription[] = _("A medal-like item in\nthe same shape as\nTEAM MAGMA’s mark.$");
const u8 gOldSeaMapItemDescription[] = _("A faded sea chart\nthat shows the way\nto a certain island.$");

const struct Item gItems[] = {

		[ITEM_NONE] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	//Pokeballs
	
	[ITEM_MASTER_BALL] = {
		.name = _("MASTER BALL$"),
		.itemId = ITEM_MASTER_BALL,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gMasterBallItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_POKE_BALLS,
		.type = 0,
		.fieldUseFunc = NULL,
		.battleUsage = 2,
		.battleUseFunc = ItemUseInBattle_PokeBall,
		.secondaryId = 0,
	},
	
	[ITEM_ULTRA_BALL] = {
		.name = _("ULTRA BALL$"),
		.itemId = ITEM_ULTRA_BALL,
		.price = 1200,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gUltraBallItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_POKE_BALLS,
		.type = 1,
		.fieldUseFunc = NULL,
		.battleUsage = 2,
		.battleUseFunc = ItemUseInBattle_PokeBall,
		.secondaryId = 1,
	},
	
	[ITEM_GREAT_BALL] = {
		.name = _("GREAT BALL$"),
		.itemId = ITEM_GREAT_BALL,
		.price = 600,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gGreatBallItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_POKE_BALLS,
		.type = 2,
		.fieldUseFunc = NULL,
		.battleUsage = 2,
		.battleUseFunc = ItemUseInBattle_PokeBall,
		.secondaryId = 2,
	},

	[ITEM_POKE_BALL] = {
		.name = _("POKé BALL$"),
		.itemId = ITEM_POKE_BALL,
		.price = 200,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gPokeBallItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_POKE_BALLS,
		.type = 3,
		.fieldUseFunc = NULL,
		.battleUsage = 2,
		.battleUseFunc = ItemUseInBattle_PokeBall,
		.secondaryId = 3,
	},
	
	[ITEM_SAFARI_BALL] = {
		.name = _("SAFARI BALL$"),
		.itemId = ITEM_SAFARI_BALL,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gSafariBallItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_POKE_BALLS,
		.type = 4,
		.fieldUseFunc = NULL,
		.battleUsage = 2,
		.battleUseFunc = ItemUseInBattle_PokeBall,
		.secondaryId = 4,
	},
	
	[ITEM_NET_BALL] = {
		.name = _("NET BALL$"),
		.itemId = ITEM_NET_BALL,
		.price = 1000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gNetBallItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_POKE_BALLS,
		.type = 5,
		.fieldUseFunc = NULL,
		.battleUsage = 2,
		.battleUseFunc = ItemUseInBattle_PokeBall,
		.secondaryId = 5,
	},
	
	[ITEM_DIVE_BALL] = {
		.name = _("DIVE BALL$"),
		.itemId = ITEM_DIVE_BALL,
		.price = 1000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDiveBallItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_POKE_BALLS,
		.type = 6,
		.fieldUseFunc = NULL,
		.battleUsage = 2,
		.battleUseFunc = ItemUseInBattle_PokeBall,
		.secondaryId = 6,
	},
	
	[ITEM_NEST_BALL] = {
		.name = _("NEST BALL$"),
		.itemId = ITEM_NEST_BALL,
		.price = 1000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gNestBallItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_POKE_BALLS,
		.type = 7,
		.fieldUseFunc = NULL,
		.battleUsage = 2,
		.battleUseFunc = ItemUseInBattle_PokeBall,
		.secondaryId = 7,
	},
	
	[ITEM_REPEAT_BALL] = {
		.name = _("REPEAT BALL$"),
		.itemId = ITEM_REPEAT_BALL,
		.price = 1000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gRepeatBallItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_POKE_BALLS,
		.type = 8,
		.fieldUseFunc = NULL,
		.battleUsage = 2,
		.battleUseFunc = ItemUseInBattle_PokeBall,
		.secondaryId = 8,
	},
	
	[ITEM_TIMER_BALL] = {
		.name = _("TIMER BALL$"),
		.itemId = ITEM_TIMER_BALL,
		.price = 1000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTimerBallItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_POKE_BALLS,
		.type = 9,
		.fieldUseFunc = NULL,
		.battleUsage = 2,
		.battleUseFunc = ItemUseInBattle_PokeBall,
		.secondaryId = 9,
	},
	
	[ITEM_LUXURY_BALL] = {
		.name = _("LUXURY BALL$"),
		.itemId = ITEM_LUXURY_BALL,
		.price = 1000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gLuxuryBallItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_POKE_BALLS,
		.type = 10,
		.fieldUseFunc = NULL,
		.battleUsage = 2,
		.battleUseFunc = ItemUseInBattle_PokeBall,
		.secondaryId = 10,
	},
	
	[ITEM_PREMIER_BALL] = {
		.name = _("PREMIER BALL$"),
		.itemId = ITEM_PREMIER_BALL,
		.price = 200,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gPremierBallItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_POKE_BALLS,
		.type = 11,
		.fieldUseFunc = NULL,
		.battleUsage = 2,
		.battleUseFunc = ItemUseInBattle_PokeBall,
		.secondaryId = 11,
	},
	
	//Medicine
	
	[ITEM_POTION] = {
		.name = _("POTION$"),
		.itemId = ITEM_POTION,
		.price = 300,
		.holdEffect = 0,
		.holdEffectParam = 20,
		.description = gPotionItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	
	[ITEM_ANTIDOTE] = {
		.name = _("ANTIDOTE$"),
		.itemId = ITEM_ANTIDOTE,
		.price = 100,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gAntidoteItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	
	[ITEM_BURN_HEAL] = {
		.name = _("BURN HEAL$"),
		.itemId = ITEM_BURN_HEAL,
		.price = 250,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gBurnHealItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	
	[ITEM_ICE_HEAL] = {
		.name = _("ICE HEAL$"),
		.itemId = ITEM_ICE_HEAL,
		.price = 250,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gIceHealItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	
	[ITEM_AWAKENING] = {
		.name = _("AWAKENING$"),
		.itemId = ITEM_AWAKENING,
		.price = 250,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gAwakeningItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},

	[ITEM_PARALYZE_HEAL] = {
		.name = _("PARLYZ HEAL$"),
		.itemId = ITEM_PARALYZE_HEAL,
		.price = 200,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gParalyzeHealItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	
	[ITEM_FULL_RESTORE] = {
		.name = _("FULL RESTORE$"),
		.itemId = ITEM_FULL_RESTORE,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 255,
		.description = gFullRestoreItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	
	[ITEM_MAX_POTION] = {
		.name = _("MAX POTION$"),
		.itemId = ITEM_MAX_POTION,
		.price = 2500,
		.holdEffect = 0,
		.holdEffectParam = 255,
		.description = gMaxPotionItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	
	[ITEM_HYPER_POTION] = {
		.name = _("HYPER POTION$"),
		.itemId = ITEM_HYPER_POTION,
		.price = 1200,
		.holdEffect = 0,
		.holdEffectParam = 200,
		.description = gHyperPotionItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	
	[ITEM_SUPER_POTION] = {
		.name = _("SUPER POTION$"),
		.itemId = ITEM_SUPER_POTION,
		.price = 700,
		.holdEffect = 0,
		.holdEffectParam = 50,
		.description = gSuperPotionItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	
	[ITEM_FULL_HEAL] = {
		.name = _("FULL HEAL$"),
		.itemId = ITEM_FULL_HEAL,
		.price = 600,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gFullHealItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	
	[ITEM_REVIVE] = {
		.name = _("REVIVE$"),
		.itemId = ITEM_REVIVE,
		.price = 1500,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gReviveItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	[ITEM_MAX_REVIVE] = {
		.name = _("MAX REVIVE$"),
		.itemId = ITEM_MAX_REVIVE,
		.price = 4000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gMaxReviveItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	[ITEM_FRESH_WATER] = {
		.name = _("FRESH WATER$"),
		.itemId = ITEM_FRESH_WATER,
		.price = 200,
		.holdEffect = 0,
		.holdEffectParam = 50,
		.description = gFreshWaterItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	
	[ITEM_SODA_POP] = {
		.name = _("SODA POP$"),
		.itemId = ITEM_SODA_POP,
		.price = 300,
		.holdEffect = 0,
		.holdEffectParam = 60,
		.description = gSodaPopItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	
	[ITEM_LEMONADE] = {
		.name = _("LEMONADE$"),
		.itemId = ITEM_LEMONADE,
		.price = 350,
		.holdEffect = 0,
		.holdEffectParam = 80,
		.description = gLemonadeItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	
	[ITEM_MOOMOO_MILK] = {
		.name = _("MOOMOO MILK$"),
		.itemId = ITEM_MOOMOO_MILK,
		.price = 500,
		.holdEffect = 0,
		.holdEffectParam = 100,
		.description = gMoomooMilkItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	
	[ITEM_ENERGY_POWDER] = {
		.name = _("ENERGYPOWDER$"),
		.itemId = ITEM_ENERGY_POWDER,
		.price = 500,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gEnergyPowderItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	
	[ITEM_ENERGY_ROOT] = {
		.name = _("ENERGY ROOT$"),
		.itemId = ITEM_ENERGY_ROOT,
		.price = 800,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gEnergyRootItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	
	[ITEM_HEAL_POWDER] = {
		.name = _("HEAL POWDER$"),
		.itemId = ITEM_HEAL_POWDER,
		.price = 450,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gHealPowderItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	
	[ITEM_REVIVAL_HERB] = {
		.name = _("REVIVAL HERB$"),
		.itemId = ITEM_REVIVAL_HERB,
		.price = 2800,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gRevivalHerbItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	
	[ITEM_ETHER] = {
		.name = _("ETHER$"),
		.itemId = ITEM_ETHER,
		.price = 1200,
		.holdEffect = 0,
		.holdEffectParam = 10,
		.description = gEtherItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_PPRecovery,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_PPRecovery,
		.secondaryId = 0,
	},
	
	[ITEM_MAX_ETHER] = {
		.name = _("MAX ETHER$"),
		.itemId = ITEM_MAX_ETHER,
		.price = 2000,
		.holdEffect = 0,
		.holdEffectParam = 255,
		.description = gMaxEtherItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_PPRecovery,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_PPRecovery,
		.secondaryId = 0,
	},
	
	[ITEM_ELIXIR] = {
		.name = _("ELIXIR$"),
		.itemId = ITEM_ELIXIR,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 10,
		.description = gElixirItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_PPRecovery,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_PPRecovery,
		.secondaryId = 0,
	},
	
	[ITEM_MAX_ELIXIR] = {
		.name = _("MAX ELIXIR$"),
		.itemId = ITEM_MAX_ELIXIR,
		.price = 4500,
		.holdEffect = 0,
		.holdEffectParam = 255,
		.description = gMaxElixirItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_PPRecovery,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_PPRecovery,
		.secondaryId = 0,
	},
	
	[ITEM_LAVA_COOKIE] = {
		.name = _("LAVA COOKIE$"),
		.itemId = ITEM_LAVA_COOKIE,
		.price = 200,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gLavaCookieItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	
	[ITEM_BLUE_FLUTE] = {
		.name = _("BLUE FLUTE$"),
		.itemId = ITEM_BLUE_FLUTE,
		.price = 100,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gBlueFluteItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	
	[ITEM_YELLOW_FLUTE] = {
		.name = _("YELLOW FLUTE$"),
		.itemId = ITEM_YELLOW_FLUTE,
		.price = 200,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gYellowFluteItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	
	[ITEM_RED_FLUTE] = {
		.name = _("RED FLUTE$"),
		.itemId = ITEM_RED_FLUTE,
		.price = 300,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gRedFluteItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	
	//Not medicine
	
	[ITEM_BLACK_FLUTE] = {
		.name = _("BLACK FLUTE$"),
		.itemId = ITEM_BLACK_FLUTE,
		.price = 400,
		.holdEffect = 0,
		.holdEffectParam = 50,
		.description = gBlackFluteItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_BlackWhiteFlute,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	[ITEM_WHITE_FLUTE] = {
		.name = _("WHITE FLUTE$"),
		.itemId = ITEM_WHITE_FLUTE,
		.price = 500,
		.holdEffect = 0,
		.holdEffectParam = 150,
		.description = gWhiteFluteItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_BlackWhiteFlute,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	//Medicine again
	
	[ITEM_BERRY_JUICE] = {
		.name = _("BERRY JUICE$"),
		.itemId = ITEM_BERRY_JUICE,
		.price = 100,
		.holdEffect = 1,
		.holdEffectParam = 20,
		.description = gBerryJuiceItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},
	
	[ITEM_SACRED_ASH] = {
		.name = _("SACRED ASH$"),
		.itemId = ITEM_SACRED_ASH,
		.price = 200,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gSacredAshItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_SacredAsh,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	//Collectibles
	
	[ITEM_SHOAL_SALT] = {
		.name = _("SHOAL SALT$"),
		.itemId = ITEM_SHOAL_SALT,
		.price = 20,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gShoalSaltItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	[ITEM_SHOAL_SHELL] = {
		.name = _("SHOAL SHELL$"),
		.itemId = ITEM_SHOAL_SHELL,
		.price = 20,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gShoalShellItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	[ITEM_RED_SHARD] = {
		.name = _("RED SHARD$"),
		.itemId = ITEM_RED_SHARD,
		.price = 200,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gRedShardItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	[ITEM_BLUE_SHARD] = {
		.name = _("BLUE SHARD$"),
		.itemId = ITEM_BLUE_SHARD,
		.price = 200,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gBlueShardItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_YELLOW_SHARD] = {
		.name = _("YELLOW SHARD$"),
		.itemId = ITEM_YELLOW_SHARD,
		.price = 200,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gYellowShardItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	[ITEM_GREEN_SHARD] = {
		.name = _("GREEN SHARD$"),
		.itemId = ITEM_GREEN_SHARD,
		.price = 200,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gGreenShardItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	//Empty Items
	
	[ITEM_034] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	[ITEM_035] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_036] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_037] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	[ITEM_038] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	[ITEM_039] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	[ITEM_03A] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_03B] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_03C] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	[ITEM_03D] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_03E] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	//Vitamins
	
	[ITEM_HP_UP] = {
		.name = _("HP UP$"),
		.itemId = ITEM_HP_UP,
		.price = 9800,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gHPUpItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_PROTEIN] = {
		.name = _("PROTEIN$"),
		.itemId = ITEM_PROTEIN,
		.price = 9800,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gProteinItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_IRON] = {
		.name = _("IRON$"),
		.itemId = ITEM_IRON,
		.price = 9800,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gIronItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_CARBOS] = {
		.name = _("CARBOS$"),
		.itemId = ITEM_CARBOS,
		.price = 9800,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gCarbosItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_CALCIUM] = {
		.name = _("CALCIUM$"),
		.itemId = ITEM_CALCIUM,
		.price = 9800,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gCalciumItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_RARE_CANDY] = {
		.name = _("RARE CANDY$"),
		.itemId = ITEM_RARE_CANDY,
		.price = 4800,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gRareCandyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_RareCandy,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_PP_UP] = {
		.name = _("PP UP$"),
		.itemId = ITEM_PP_UP,
		.price = 9800,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gPPUpItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_PPUp,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_ZINC] = {
		.name = _("ZINC$"),
		.itemId = ITEM_ZINC,
		.price = 9800,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gZincItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_PP_MAX] = {
		.name = _("PP MAX$"),
		.itemId = ITEM_PP_MAX,
		.price = 9800,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gPPMaxItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_PPUp,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_048] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	//battle items
	
	[ITEM_GUARD_SPEC] = {
		.name = _("GUARD SPEC.$"),
		.itemId = ITEM_GUARD_SPEC,
		.price = 700,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gGuardSpecItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 2,
		.battleUseFunc = ItemUseInBattle_StatIncrease,
		.secondaryId = 0,
	},	

	[ITEM_DIRE_HIT] = {
		.name = _("DIRE HIT$"),
		.itemId = ITEM_DIRE_HIT,
		.price = 650,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDireHitItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 2,
		.battleUseFunc = ItemUseInBattle_StatIncrease,
		.secondaryId = 0,
	},	

	[ITEM_X_ATTACK] = {
		.name = _("X ATTACK$"),
		.itemId = ITEM_X_ATTACK,
		.price = 500,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gXAttackItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 2,
		.battleUseFunc = ItemUseInBattle_StatIncrease,
		.secondaryId = 0,
	},	

	[ITEM_X_DEFEND] = {
		.name = _("X DEFEND$"),
		.itemId = ITEM_X_DEFEND,
		.price = 550,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gXDefendItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 2,
		.battleUseFunc = ItemUseInBattle_StatIncrease,
		.secondaryId = 0,
	},	

	[ITEM_X_SPEED] = {
		.name = _("X SPEED$"),
		.itemId = ITEM_X_SPEED,
		.price = 350,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gXSpeedItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 2,
		.battleUseFunc = ItemUseInBattle_StatIncrease,
		.secondaryId = 0,
	},	

	[ITEM_X_ACCURACY] = {
		.name = _("X ACCURACY$"),
		.itemId = ITEM_X_ACCURACY,
		.price = 950,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gXAccuracyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 2,
		.battleUseFunc = ItemUseInBattle_StatIncrease,
		.secondaryId = 0,
	},	

	[ITEM_X_SPECIAL] = {
		.name = _("X SPECIAL$"),
		.itemId = ITEM_X_SPECIAL,
		.price = 350,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gXSpecialItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 2,
		.battleUseFunc = ItemUseInBattle_StatIncrease,
		.secondaryId = 0,
	},	

	[ITEM_POKE_DOLL] = {
		.name = _("POKé DOLL$"),
		.itemId = ITEM_POKE_DOLL,
		.price = 1000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gPokeDollItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 2,
		.battleUseFunc = ItemUseInBattle_Escape,
		.secondaryId = 0,
	},	

	[ITEM_FLUFFY_TAIL] = {
		.name = _("FLUFFY TAIL$"),
		.itemId = ITEM_FLUFFY_TAIL,
		.price = 1000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gFluffyTailItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 2,
		.battleUseFunc = ItemUseInBattle_Escape,
		.secondaryId = 0,
	},	

	[ITEM_052] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
//field items

	[ITEM_SUPER_REPEL] = {
		.name = _("SUPER REPEL$"),
		.itemId = ITEM_SUPER_REPEL,
		.price = 500,
		.holdEffect = 0,
		.holdEffectParam = 200,
		.description = gSuperRepelItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_Repel,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_MAX_REPEL] = {
		.name = _("MAX REPEL$"),
		.itemId = ITEM_MAX_REPEL,
		.price = 700,
		.holdEffect = 0,
		.holdEffectParam = 250,
		.description = gMaxRepelItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_Repel,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_ESCAPE_ROPE] = {
		.name = _("ESCAPE ROPE$"),
		.itemId = ITEM_ESCAPE_ROPE,
		.price = 550,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gEscapeRopeItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 2,
		.fieldUseFunc = ItemUseOutOfBattle_EscapeRope,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_REPEL] = {
		.name = _("REPEL$"),
		.itemId = ITEM_REPEL,
		.price = 350,
		.holdEffect = 0,
		.holdEffectParam = 100,
		.description = gRepelItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_Repel,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

//Empty items #2

	[ITEM_057] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	[ITEM_058] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	[ITEM_059] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	[ITEM_05A] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	[ITEM_05B] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	[ITEM_05C] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
//Evolution Stones

	[ITEM_SUN_STONE] = {
		.name = _("SUN STONE$"),
		.itemId = ITEM_SUN_STONE,
		.price = 2100,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gSunStoneItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_EvolutionStone,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	[ITEM_MOON_STONE] = {
		.name = _("MOON STONE$"),
		.itemId = ITEM_MOON_STONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gMoonStoneItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_EvolutionStone,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_FIRE_STONE] = {
		.name = _("FIRE STONE$"),
		.itemId = ITEM_FIRE_STONE,
		.price = 2100,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gFireStoneItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_EvolutionStone,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_THUNDER_STONE] = {
		.name = _("THUNDERSTONE$"),
		.itemId = ITEM_THUNDER_STONE,
		.price = 2100,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gThunderStoneItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_EvolutionStone,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_WATER_STONE] = {
		.name = _("WATER STONE$"),
		.itemId = ITEM_WATER_STONE,
		.price = 2100,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gWaterStoneItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_EvolutionStone,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_LEAF_STONE] = {
		.name = _("LEAF STONE$"),
		.itemId = ITEM_LEAF_STONE,
		.price = 2100,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gLeafStoneItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_EvolutionStone,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

//Empty items #3

	[ITEM_063] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	[ITEM_064] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_065] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_066] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

//Valuable items
	[ITEM_TINY_MUSHROOM] = {
		.name = _("TINYMUSHROOM$"),
		.itemId = ITEM_TINY_MUSHROOM,
		.price = 500,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTinyMushroomItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_BIG_MUSHROOM] = {
		.name = _("BIG MUSHROOM$"),
		.itemId = ITEM_BIG_MUSHROOM,
		.price = 5000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gBigMushroomItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_069] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	[ITEM_PEARL] = {
		.name = _("PEARL$"),
		.itemId = ITEM_PEARL,
		.price = 1400,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gPearlItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_BIG_PEARL] = {
		.name = _("BIG PEARL$"),
		.itemId = ITEM_BIG_PEARL,
		.price = 7500,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gBigPearlItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_STARDUST] = {
		.name = _("STARDUST$"),
		.itemId = ITEM_STARDUST,
		.price = 2000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gStardustItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_STAR_PIECE] = {
		.name = _("STAR PIECE$"),
		.itemId = ITEM_STAR_PIECE,
		.price = 9800,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gStarPieceItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_NUGGET] = {
		.name = _("NUGGET$"),
		.itemId = ITEM_NUGGET,
		.price = 10000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gNuggetItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_HEART_SCALE] = {
		.name = _("HEART SCALE$"),
		.itemId = ITEM_HEART_SCALE,
		.price = 100,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gHeartScaleItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
//empty items

	[ITEM_070] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	[ITEM_071] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_072] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_073] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	[ITEM_074] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	[ITEM_075] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_076] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_077] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	[ITEM_078] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

//mail

	[ITEM_ORANGE_MAIL] = {
		.name = _("ORANGE MAIL$"),
		.itemId = ITEM_ORANGE_MAIL,
		.price = 50,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gOrangeMailItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 0,
		.fieldUseFunc = ItemUseOutOfBattle_Mail,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_HARBOR_MAIL] = {
		.name = _("HARBOR MAIL$"),
		.itemId = ITEM_HARBOR_MAIL,
		.price = 50,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gHarborMailItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 0,
		.fieldUseFunc = ItemUseOutOfBattle_Mail,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 1,
	},

	[ITEM_GLITTER_MAIL] = {
		.name = _("GLITTER MAIL$"),
		.itemId = ITEM_GLITTER_MAIL,
		.price = 50,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gGlitterMailItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 0,
		.fieldUseFunc = ItemUseOutOfBattle_Mail,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 2,
	},

	[ITEM_MECH_MAIL] = {
		.name = _("MECH MAIL$"),
		.itemId = ITEM_MECH_MAIL,
		.price = 50,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gMechMailItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 0,
		.fieldUseFunc = ItemUseOutOfBattle_Mail,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 3,
	},

	[ITEM_WOOD_MAIL] = {
		.name = _("WOOD MAIL$"),
		.itemId = ITEM_WOOD_MAIL,
		.price = 50,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gWoodMailItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 0,
		.fieldUseFunc = ItemUseOutOfBattle_Mail,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 4,
	},

	[ITEM_WAVE_MAIL] = {
		.name = _("WAVE MAIL$"),
		.itemId = ITEM_WAVE_MAIL,
		.price = 50,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gWaveMailItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 0,
		.fieldUseFunc = ItemUseOutOfBattle_Mail,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 5,
	},

	[ITEM_BEAD_MAIL] = {
		.name = _("BEAD MAIL$"),
		.itemId = ITEM_BEAD_MAIL,
		.price = 50,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gBeadMailItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 0,
		.fieldUseFunc = ItemUseOutOfBattle_Mail,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 6,
	},

	[ITEM_SHADOW_MAIL] = {
		.name = _("SHADOW MAIL$"),
		.itemId = ITEM_SHADOW_MAIL,
		.price = 50,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gShadowMailItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 0,
		.fieldUseFunc = ItemUseOutOfBattle_Mail,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 7,
	},

	[ITEM_TROPIC_MAIL] = {
		.name = _("TROPIC MAIL$"),
		.itemId = ITEM_TROPIC_MAIL,
		.price = 50,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTropicMailItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 0,
		.fieldUseFunc = ItemUseOutOfBattle_Mail,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 8,
	},

	[ITEM_DREAM_MAIL] = {
		.name = _("DREAM MAIL$"),
		.itemId = ITEM_DREAM_MAIL,
		.price = 50,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDreamMailItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 0,
		.fieldUseFunc = ItemUseOutOfBattle_Mail,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 9,
	},

	[ITEM_FAB_MAIL] = {
		.name = _("FAB MAIL$"),
		.itemId = ITEM_FAB_MAIL,
		.price = 50,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gFabMailItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 0,
		.fieldUseFunc = ItemUseOutOfBattle_Mail,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 10,
	},

	[ITEM_RETRO_MAIL] = {
		.name = _("RETRO MAIL$"),
		.itemId = ITEM_RETRO_MAIL,
		.price = 50,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gRetroMailItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 0,
		.fieldUseFunc = ItemUseOutOfBattle_Mail,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 11,
	},

//berries

	[ITEM_CHERI_BERRY] = {
		.name = _("CHERI BERRY$"),
		.itemId = ITEM_CHERI_BERRY,
		.price = 20,
		.holdEffect = 2,
		.holdEffectParam = 0,
		.description = gCheriBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},

	[ITEM_CHESTO_BERRY] = {
		.name = _("CHESTO BERRY$"),
		.itemId = ITEM_CHESTO_BERRY,
		.price = 20,
		.holdEffect = 3,
		.holdEffectParam = 0,
		.description = gChestoBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},

	[ITEM_PECHA_BERRY] = {
		.name = _("PECHA BERRY$"),
		.itemId = ITEM_PECHA_BERRY,
		.price = 20,
		.holdEffect = 4,
		.holdEffectParam = 0,
		.description = gPechaBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},

	[ITEM_RAWST_BERRY] = {
		.name = _("RAWST BERRY$"),
		.itemId = ITEM_RAWST_BERRY,
		.price = 20,
		.holdEffect = 5,
		.holdEffectParam = 0,
		.description = gRawstBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},

	[ITEM_ASPEAR_BERRY] = {
		.name = _("ASPEAR BERRY$"),
		.itemId = ITEM_ASPEAR_BERRY,
		.price = 20,
		.holdEffect = 6,
		.holdEffectParam = 0,
		.description = gAspearBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},

	[ITEM_LEPPA_BERRY] = {
		.name = _("LEPPA BERRY$"),
		.itemId = ITEM_LEPPA_BERRY,
		.price = 20,
		.holdEffect = 7,
		.holdEffectParam = 10,
		.description = gLeppaBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_PPRecovery,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_PPRecovery,
		.secondaryId = 0,
	},

	[ITEM_ORAN_BERRY] = {
		.name = _("ORAN BERRY$"),
		.itemId = ITEM_ORAN_BERRY,
		.price = 20,
		.holdEffect = 1,
		.holdEffectParam = 10,
		.description = gOranBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},

	[ITEM_PERSIM_BERRY] = {
		.name = _("PERSIM BERRY$"),
		.itemId = ITEM_PERSIM_BERRY,
		.price = 20,
		.holdEffect = 8,
		.holdEffectParam = 0,
		.description = gPersimBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},

	[ITEM_LUM_BERRY] = {
		.name = _("LUM BERRY$"),
		.itemId = ITEM_LUM_BERRY,
		.price = 20,
		.holdEffect = 9,
		.holdEffectParam = 0,
		.description = gLumBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},

	[ITEM_SITRUS_BERRY] = {
		.name = _("SITRUS BERRY$"),
		.itemId = ITEM_SITRUS_BERRY,
		.price = 20,
		.holdEffect = 1,
		.holdEffectParam = 30,
		.description = gSitrusBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_Medicine,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_Medicine,
		.secondaryId = 0,
	},

	[ITEM_FIGY_BERRY] = {
		.name = _("FIGY BERRY$"),
		.itemId = ITEM_FIGY_BERRY,
		.price = 20,
		.holdEffect = 10,
		.holdEffectParam = 8,
		.description = gFigyBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_WIKI_BERRY] = {
		.name = _("WIKI BERRY$"),
		.itemId = ITEM_WIKI_BERRY,
		.price = 20,
		.holdEffect = 11,
		.holdEffectParam = 8,
		.description = gWikiBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_MAGO_BERRY] = {
		.name = _("MAGO BERRY$"),
		.itemId = ITEM_MAGO_BERRY,
		.price = 20,
		.holdEffect = 12,
		.holdEffectParam = 8,
		.description = gMagoBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_AGUAV_BERRY] = {
		.name = _("AGUAV BERRY$"),
		.itemId = ITEM_AGUAV_BERRY,
		.price = 20,
		.holdEffect = 13,
		.holdEffectParam = 8,
		.description = gAguavBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_IAPAPA_BERRY] = {
		.name = _("IAPAPA BERRY$"),
		.itemId = ITEM_IAPAPA_BERRY,
		.price = 20,
		.holdEffect = 14,
		.holdEffectParam = 8,
		.description = gIapapaBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_RAZZ_BERRY] = {
		.name = _("RAZZ BERRY$"),
		.itemId = ITEM_RAZZ_BERRY,
		.price = 20,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gRazzBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_BLUK_BERRY] = {
		.name = _("BLUK BERRY$"),
		.itemId = ITEM_BLUK_BERRY,
		.price = 20,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gBlukBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_NANAB_BERRY] = {
		.name = _("NANAB BERRY$"),
		.itemId = ITEM_NANAB_BERRY,
		.price = 20,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gNanabBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_WEPEAR_BERRY] = {
		.name = _("WEPEAR BERRY$"),
		.itemId = ITEM_WEPEAR_BERRY,
		.price = 20,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gWepearBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_PINAP_BERRY] = {
		.name = _("PINAP BERRY$"),
		.itemId = ITEM_PINAP_BERRY,
		.price = 20,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gPinapBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_POMEG_BERRY] = {
		.name = _("POMEG BERRY$"),
		.itemId = ITEM_POMEG_BERRY,
		.price = 20,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gPomegBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_ReduceEV,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_KELPSY_BERRY] = {
		.name = _("KELPSY BERRY$"),
		.itemId = ITEM_KELPSY_BERRY,
		.price = 20,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gKelpsyBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_ReduceEV,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_QUALOT_BERRY] = {
		.name = _("QUALOT BERRY$"),
		.itemId = ITEM_QUALOT_BERRY,
		.price = 20,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gQualotBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_ReduceEV,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_HONDEW_BERRY] = {
		.name = _("HONDEW BERRY$"),
		.itemId = ITEM_HONDEW_BERRY,
		.price = 20,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gHondewBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_ReduceEV,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_GREPA_BERRY] = {
		.name = _("GREPA BERRY$"),
		.itemId = ITEM_GREPA_BERRY,
		.price = 20,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gGrepaBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_ReduceEV,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TAMATO_BERRY] = {
		.name = _("TAMATO BERRY$"),
		.itemId = ITEM_TAMATO_BERRY,
		.price = 20,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTamatoBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_ReduceEV,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_CORNN_BERRY] = {
		.name = _("CORNN BERRY$"),
		.itemId = ITEM_CORNN_BERRY,
		.price = 20,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gCornnBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_MAGOST_BERRY] = {
		.name = _("MAGOST BERRY$"),
		.itemId = ITEM_MAGOST_BERRY,
		.price = 20,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gMagostBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_RABUTA_BERRY] = {
		.name = _("RABUTA BERRY$"),
		.itemId = ITEM_RABUTA_BERRY,
		.price = 20,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gRabutaBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_NOMEL_BERRY] = {
		.name = _("NOMEL BERRY$"),
		.itemId = ITEM_NOMEL_BERRY,
		.price = 20,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gNomelBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_SPELON_BERRY] = {
		.name = _("SPELON BERRY$"),
		.itemId = ITEM_SPELON_BERRY,
		.price = 20,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gSpelonBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_PAMTRE_BERRY] = {
		.name = _("PAMTRE BERRY$"),
		.itemId = ITEM_PAMTRE_BERRY,
		.price = 20,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gPamtreBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_WATMEL_BERRY] = {
		.name = _("WATMEL BERRY$"),
		.itemId = ITEM_WATMEL_BERRY,
		.price = 20,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gWatmelBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_DURIN_BERRY] = {
		.name = _("DURIN BERRY$"),
		.itemId = ITEM_DURIN_BERRY,
		.price = 20,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDurinBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_BELUE_BERRY] = {
		.name = _("BELUE BERRY$"),
		.itemId = ITEM_BELUE_BERRY,
		.price = 20,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gBelueBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_LIECHI_BERRY] = {
		.name = _("LIECHI BERRY$"),
		.itemId = ITEM_LIECHI_BERRY,
		.price = 20,
		.holdEffect = 15,
		.holdEffectParam = 4,
		.description = gLiechiBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_GANLON_BERRY] = {
		.name = _("GANLON BERRY$"),
		.itemId = ITEM_GANLON_BERRY,
		.price = 20,
		.holdEffect = 16,
		.holdEffectParam = 4,
		.description = gGanlonBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_SALAC_BERRY] = {
		.name = _("SALAC BERRY$"),
		.itemId = ITEM_SALAC_BERRY,
		.price = 20,
		.holdEffect = 17,
		.holdEffectParam = 4,
		.description = gSalacBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_PETAYA_BERRY] = {
		.name = _("PETAYA BERRY$"),
		.itemId = ITEM_PETAYA_BERRY,
		.price = 20,
		.holdEffect = 18,
		.holdEffectParam = 4,
		.description = gPetayaBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_APICOT_BERRY] = {
		.name = _("APICOT BERRY$"),
		.itemId = ITEM_APICOT_BERRY,
		.price = 20,
		.holdEffect = 19,
		.holdEffectParam = 4,
		.description = gApicotBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_LANSAT_BERRY] = {
		.name = _("LANSAT BERRY$"),
		.itemId = ITEM_LANSAT_BERRY,
		.price = 20,
		.holdEffect = 20,
		.holdEffectParam = 4,
		.description = gLansatBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_STARF_BERRY] = {
		.name = _("STARF BERRY$"),
		.itemId = ITEM_STARF_BERRY,
		.price = 20,
		.holdEffect = 21,
		.holdEffectParam = 4,
		.description = gStarfBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_ENIGMA_BERRY] = {
		.name = _("ENIGMA BERRY$"),
		.itemId = ITEM_ENIGMA_BERRY,
		.price = 20,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gEnigmaBerryItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_BERRIES,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_EnigmaBerry,
		.battleUsage = 1,
		.battleUseFunc = ItemUseInBattle_EnigmaBerry,
		.secondaryId = 0,
	},

//empty items

	[ITEM_0B0] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0B1] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0B2] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

//hold items

	[ITEM_BRIGHT_POWDER] = {
		.name = _("BRIGHTPOWDER$"),
		.itemId = ITEM_BRIGHT_POWDER,
		.price = 10,
		.holdEffect = 22,
		.holdEffectParam = 10,
		.description = gBrightPowderItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_WHITE_HERB] = {
		.name = _("WHITE HERB$"),
		.itemId = ITEM_WHITE_HERB,
		.price = 100,
		.holdEffect = 23,
		.holdEffectParam = 0,
		.description = gWhiteHerbItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_MACHO_BRACE] = {
		.name = _("MACHO BRACE$"),
		.itemId = ITEM_MACHO_BRACE,
		.price = 3000,
		.holdEffect = 24,
		.holdEffectParam = 0,
		.description = gMachoBraceItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_EXP_SHARE] = {
		.name = _("EXP. SHARE$"),
		.itemId = ITEM_EXP_SHARE,
		.price = 3000,
		.holdEffect = 25,
		.holdEffectParam = 0,
		.description = gExpShareItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_QUICK_CLAW] = {
		.name = _("QUICK CLAW$"),
		.itemId = ITEM_QUICK_CLAW,
		.price = 100,
		.holdEffect = 26,
		.holdEffectParam = 20,
		.description = gQuickClawItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_SOOTHE_BELL] = {
		.name = _("SOOTHE BELL$"),
		.itemId = ITEM_SOOTHE_BELL,
		.price = 100,
		.holdEffect = 27,
		.holdEffectParam = 0,
		.description = gSootheBellItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_MENTAL_HERB] = {
		.name = _("MENTAL HERB$"),
		.itemId = ITEM_MENTAL_HERB,
		.price = 100,
		.holdEffect = 28,
		.holdEffectParam = 0,
		.description = gMentalHerbItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_CHOICE_BAND] = {
		.name = _("CHOICE BAND$"),
		.itemId = ITEM_CHOICE_BAND,
		.price = 100,
		.holdEffect = 29,
		.holdEffectParam = 0,
		.description = gChoiceBandItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_KINGS_ROCK] = {
		.name = _("KING’S ROCK$"),
		.itemId = ITEM_KINGS_ROCK,
		.price = 100,
		.holdEffect = 30,
		.holdEffectParam = 10,
		.description = gKingsRockItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_SILVER_POWDER] = {
		.name = _("SILVERPOWDER$"),
		.itemId = ITEM_SILVER_POWDER,
		.price = 100,
		.holdEffect = 31,
		.holdEffectParam = 10,
		.description = gSilverPowderItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_AMULET_COIN] = {
		.name = _("AMULET COIN$"),
		.itemId = ITEM_AMULET_COIN,
		.price = 100,
		.holdEffect = 32,
		.holdEffectParam = 10,
		.description = gAmuletCoinItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_CLEANSE_TAG] = {
		.name = _("CLEANSE TAG$"),
		.itemId = ITEM_CLEANSE_TAG,
		.price = 200,
		.holdEffect = 33,
		.holdEffectParam = 0,
		.description = gCleanseTagItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_SOUL_DEW] = {
		.name = _("SOUL DEW$"),
		.itemId = ITEM_SOUL_DEW,
		.price = 200,
		.holdEffect = 34,
		.holdEffectParam = 0,
		.description = gSoulDewItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_DEEP_SEA_TOOTH] = {
		.name = _("DEEPSEATOOTH$"),
		.itemId = ITEM_DEEP_SEA_TOOTH,
		.price = 200,
		.holdEffect = 35,
		.holdEffectParam = 0,
		.description = gDeepSeaToothItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_DEEP_SEA_SCALE] = {
		.name = _("DEEPSEASCALE$"),
		.itemId = ITEM_DEEP_SEA_SCALE,
		.price = 200,
		.holdEffect = 36,
		.holdEffectParam = 0,
		.description = gDeepSeaScaleItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_SMOKE_BALL] = {
		.name = _("SMOKE BALL$"),
		.itemId = ITEM_SMOKE_BALL,
		.price = 200,
		.holdEffect = 37,
		.holdEffectParam = 0,
		.description = gSmokeBallItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_EVERSTONE] = {
		.name = _("EVERSTONE$"),
		.itemId = ITEM_EVERSTONE,
		.price = 200,
		.holdEffect = 38,
		.holdEffectParam = 0,
		.description = gEverstoneItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_FOCUS_BAND] = {
		.name = _("FOCUS BAND$"),
		.itemId = ITEM_FOCUS_BAND,
		.price = 200,
		.holdEffect = 39,
		.holdEffectParam = 10,
		.description = gFocusBandItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_LUCKY_EGG] = {
		.name = _("LUCKY EGG$"),
		.itemId = ITEM_LUCKY_EGG,
		.price = 200,
		.holdEffect = 40,
		.holdEffectParam = 0,
		.description = gLuckyEggItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_SCOPE_LENS] = {
		.name = _("SCOPE LENS$"),
		.itemId = ITEM_SCOPE_LENS,
		.price = 200,
		.holdEffect = 41,
		.holdEffectParam = 0,
		.description = gScopeLensItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_METAL_COAT] = {
		.name = _("METAL COAT$"),
		.itemId = ITEM_METAL_COAT,
		.price = 100,
		.holdEffect = 42,
		.holdEffectParam = 10,
		.description = gMetalCoatItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_LEFTOVERS] = {
		.name = _("LEFTOVERS$"),
		.itemId = ITEM_LEFTOVERS,
		.price = 200,
		.holdEffect = 43,
		.holdEffectParam = 10,
		.description = gLeftoversItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_DRAGON_SCALE] = {
		.name = _("DRAGON SCALE$"),
		.itemId = ITEM_DRAGON_SCALE,
		.price = 2100,
		.holdEffect = 44,
		.holdEffectParam = 10,
		.description = gDragonScaleItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_LIGHT_BALL] = {
		.name = _("LIGHT BALL$"),
		.itemId = ITEM_LIGHT_BALL,
		.price = 100,
		.holdEffect = 45,
		.holdEffectParam = 0,
		.description = gLightBallItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_SOFT_SAND] = {
		.name = _("SOFT SAND$"),
		.itemId = ITEM_SOFT_SAND,
		.price = 100,
		.holdEffect = 46,
		.holdEffectParam = 10,
		.description = gSoftSandItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_HARD_STONE] = {
		.name = _("HARD STONE$"),
		.itemId = ITEM_HARD_STONE,
		.price = 100,
		.holdEffect = 47,
		.holdEffectParam = 10,
		.description = gHardStoneItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_MIRACLE_SEED] = {
		.name = _("MIRACLE SEED$"),
		.itemId = ITEM_MIRACLE_SEED,
		.price = 100,
		.holdEffect = 48,
		.holdEffectParam = 10,
		.description = gMiracleSeedItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_BLACK_GLASSES] = {
		.name = _("BLACKGLASSES$"),
		.itemId = ITEM_BLACK_GLASSES,
		.price = 100,
		.holdEffect = 49,
		.holdEffectParam = 10,
		.description = gBlackGlassesItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_BLACK_BELT] = {
		.name = _("BLACK BELT$"),
		.itemId = ITEM_BLACK_BELT,
		.price = 100,
		.holdEffect = 50,
		.holdEffectParam = 10,
		.description = gBlackBeltItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_MAGNET] = {
		.name = _("MAGNET$"),
		.itemId = ITEM_MAGNET,
		.price = 100,
		.holdEffect = 51,
		.holdEffectParam = 10,
		.description = gMagnetItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_MYSTIC_WATER] = {
		.name = _("MYSTIC WATER$"),
		.itemId = ITEM_MYSTIC_WATER,
		.price = 100,
		.holdEffect = 52,
		.holdEffectParam = 10,
		.description = gMysticWaterItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_SHARP_BEAK] = {
		.name = _("SHARP BEAK$"),
		.itemId = ITEM_SHARP_BEAK,
		.price = 100,
		.holdEffect = 53,
		.holdEffectParam = 10,
		.description = gSharpBeakItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_POISON_BARB] = {
		.name = _("POISON BARB$"),
		.itemId = ITEM_POISON_BARB,
		.price = 100,
		.holdEffect = 54,
		.holdEffectParam = 10,
		.description = gPoisonBarbItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_NEVER_MELT_ICE] = {
		.name = _("NEVERMELTICE$"),
		.itemId = ITEM_NEVER_MELT_ICE,
		.price = 100,
		.holdEffect = 55,
		.holdEffectParam = 10,
		.description = gNeverMeltIceItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_SPELL_TAG] = {
		.name = _("SPELL TAG$"),
		.itemId = ITEM_SPELL_TAG,
		.price = 100,
		.holdEffect = 56,
		.holdEffectParam = 10,
		.description = gSpellTagItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TWISTED_SPOON] = {
		.name = _("TWISTEDSPOON$"),
		.itemId = ITEM_TWISTED_SPOON,
		.price = 100,
		.holdEffect = 57,
		.holdEffectParam = 10,
		.description = gTwistedSpoonItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_CHARCOAL] = {
		.name = _("CHARCOAL$"),
		.itemId = ITEM_CHARCOAL,
		.price = 9800,
		.holdEffect = 58,
		.holdEffectParam = 10,
		.description = gCharcoalItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_DRAGON_FANG] = {
		.name = _("DRAGON FANG$"),
		.itemId = ITEM_DRAGON_FANG,
		.price = 100,
		.holdEffect = 59,
		.holdEffectParam = 10,
		.description = gDragonFangItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_SILK_SCARF] = {
		.name = _("SILK SCARF$"),
		.itemId = ITEM_SILK_SCARF,
		.price = 100,
		.holdEffect = 60,
		.holdEffectParam = 10,
		.description = gSilkScarfItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_UP_GRADE] = {
		.name = _("UP-GRADE$"),
		.itemId = ITEM_UP_GRADE,
		.price = 2100,
		.holdEffect = 61,
		.holdEffectParam = 0,
		.description = gUpGradeItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_SHELL_BELL] = {
		.name = _("SHELL BELL$"),
		.itemId = ITEM_SHELL_BELL,
		.price = 200,
		.holdEffect = 62,
		.holdEffectParam = 8,
		.description = gShellBellItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_SEA_INCENSE] = {
		.name = _("SEA INCENSE$"),
		.itemId = ITEM_SEA_INCENSE,
		.price = 9600,
		.holdEffect = 52,
		.holdEffectParam = 5,
		.description = gSeaIncenseItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_LAX_INCENSE] = {
		.name = _("LAX INCENSE$"),
		.itemId = ITEM_LAX_INCENSE,
		.price = 9600,
		.holdEffect = 22,
		.holdEffectParam = 5,
		.description = gLaxIncenseItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_LUCKY_PUNCH] = {
		.name = _("LUCKY PUNCH$"),
		.itemId = ITEM_LUCKY_PUNCH,
		.price = 10,
		.holdEffect = 63,
		.holdEffectParam = 0,
		.description = gLuckyPunchItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_METAL_POWDER] = {
		.name = _("METAL POWDER$"),
		.itemId = ITEM_METAL_POWDER,
		.price = 10,
		.holdEffect = 64,
		.holdEffectParam = 0,
		.description = gMetalPowderItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_THICK_CLUB] = {
		.name = _("THICK CLUB$"),
		.itemId = ITEM_THICK_CLUB,
		.price = 500,
		.holdEffect = 65,
		.holdEffectParam = 0,
		.description = gThickClubItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_STICK] = {
		.name = _("STICK$"),
		.itemId = ITEM_STICK,
		.price = 200,
		.holdEffect = 66,
		.holdEffectParam = 0,
		.description = gStickItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

//empty items

	[ITEM_0E2] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0E3] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0E4] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0E5] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0E6] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0E7] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0E8] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0E9] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0EA] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0EB] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0EC] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0ED] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0EE] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0EF] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0F0] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0F1] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0F2] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0F3] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0F4] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0F5] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0F6] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0F7] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0F8] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0F9] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0FA] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0FB] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0FC] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_0FD] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

//hold items continued

	[ITEM_RED_SCARF] = {
		.name = _("RED SCARF$"),
		.itemId = ITEM_RED_SCARF,
		.price = 100,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gRedScarfItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_BLUE_SCARF] = {
		.name = _("BLUE SCARF$"),
		.itemId = ITEM_BLUE_SCARF,
		.price = 100,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gBlueScarfItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_PINK_SCARF] = {
		.name = _("PINK SCARF$"),
		.itemId = ITEM_PINK_SCARF,
		.price = 100,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gPinkScarfItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_GREEN_SCARF] = {
		.name = _("GREEN SCARF$"),
		.itemId = ITEM_GREEN_SCARF,
		.price = 100,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gGreenScarfItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_YELLOW_SCARF] = {
		.name = _("YELLOW SCARF$"),
		.itemId = ITEM_YELLOW_SCARF,
		.price = 100,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gYellowScarfItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

//Key items

	[ITEM_MACH_BIKE] = {
		.name = _("MACH BIKE$"),
		.itemId = ITEM_MACH_BIKE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gMachBikeItemDescription,
		.importance = 1,
		.unk19 = 1,
		.pocket = POCKET_KEY_ITEMS,
		.type = 2,
		.fieldUseFunc = ItemUseOutOfBattle_Bike,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_COIN_CASE] = {
		.name = _("COIN CASE$"),
		.itemId = ITEM_COIN_CASE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gCoinCaseItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CoinCase,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_ITEMFINDER] = {
		.name = _("ITEMFINDER$"),
		.itemId = ITEM_ITEMFINDER,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gItemfinderItemDescription,
		.importance = 1,
		.unk19 = 1,
		.pocket = POCKET_KEY_ITEMS,
		.type = 2,
		.fieldUseFunc = ItemUseOutOfBattle_Itemfinder,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_OLD_ROD] = {
		.name = _("OLD ROD$"),
		.itemId = ITEM_OLD_ROD,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gOldRodItemDescription,
		.importance = 1,
		.unk19 = 1,
		.pocket = POCKET_KEY_ITEMS,
		.type = 2,
		.fieldUseFunc = ItemUseOutOfBattle_Rod,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_GOOD_ROD] = {
		.name = _("GOOD ROD$"),
		.itemId = ITEM_GOOD_ROD,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gGoodRodItemDescription,
		.importance = 1,
		.unk19 = 1,
		.pocket = POCKET_KEY_ITEMS,
		.type = 2,
		.fieldUseFunc = ItemUseOutOfBattle_Rod,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 1,
	},

	[ITEM_SUPER_ROD] = {
		.name = _("SUPER ROD$"),
		.itemId = ITEM_SUPER_ROD,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gSuperRodItemDescription,
		.importance = 1,
		.unk19 = 1,
		.pocket = POCKET_KEY_ITEMS,
		.type = 2,
		.fieldUseFunc = ItemUseOutOfBattle_Rod,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 2,
	},

	[ITEM_SS_TICKET] = {
		.name = _("S.S. TICKET$"),
		.itemId = ITEM_SS_TICKET,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gSSTicketItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_CONTEST_PASS] = {
		.name = _("CONTEST PASS$"),
		.itemId = ITEM_CONTEST_PASS,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gContestPassItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},
	
	[ITEM_10B] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_WAILMER_PAIL] = {
		.name = _("WAILMER PAIL$"),
		.itemId = ITEM_WAILMER_PAIL,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gWailmerPailItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 2,
		.fieldUseFunc = ItemUseOutOfBattle_WailmerPail,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_DEVON_GOODS] = {
		.name = _("DEVON GOODS$"),
		.itemId = ITEM_DEVON_GOODS,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDevonGoodsItemDescription,
		.importance = 2,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_SOOT_SACK] = {
		.name = _("SOOT SACK$"),
		.itemId = ITEM_SOOT_SACK,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gSootSackItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_BASEMENT_KEY] = {
		.name = _("BASEMENT KEY$"),
		.itemId = ITEM_BASEMENT_KEY,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gBasementKeyItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_ACRO_BIKE] = {
		.name = _("ACRO BIKE$"),
		.itemId = ITEM_ACRO_BIKE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gAcroBikeItemDescription,
		.importance = 1,
		.unk19 = 1,
		.pocket = POCKET_KEY_ITEMS,
		.type = 2,
		.fieldUseFunc = ItemUseOutOfBattle_Bike,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 1,
	},

	[ITEM_POKEBLOCK_CASE] = {
		.name = _("{POKEBLOCK} CASE$"),
		.itemId = ITEM_POKEBLOCK_CASE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gPokeblockCaseItemDescription,
		.importance = 1,
		.unk19 = 1,
		.pocket = POCKET_KEY_ITEMS,
		.type = 3,
		.fieldUseFunc = ItemUseOutOfBattle_PokeblockCase,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_LETTER] = {
		.name = _("LETTER$"),
		.itemId = ITEM_LETTER,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gLetterItemDescription,
		.importance = 2,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_EON_TICKET] = {
		.name = _("EON TICKET$"),
		.itemId = ITEM_EON_TICKET,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gEonTicketItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 1,
	},

	[ITEM_RED_ORB] = {
		.name = _("RED ORB$"),
		.itemId = ITEM_RED_ORB,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gRedOrbItemDescription,
		.importance = 2,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_BLUE_ORB] = {
		.name = _("BLUE ORB$"),
		.itemId = ITEM_BLUE_ORB,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gBlueOrbItemDescription,
		.importance = 2,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_SCANNER] = {
		.name = _("SCANNER$"),
		.itemId = ITEM_SCANNER,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gScannerItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_GO_GOGGLES] = {
		.name = _("GO-GOGGLES$"),
		.itemId = ITEM_GO_GOGGLES,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gGoGogglesItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_METEORITE] = {
		.name = _("METEORITE$"),
		.itemId = ITEM_METEORITE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gMeteoriteItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_ROOM_1_KEY] = {
		.name = _("RM. 1 KEY$"),
		.itemId = ITEM_ROOM_1_KEY,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gRoom1KeyItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_ROOM_2_KEY] = {
		.name = _("RM. 2 KEY$"),
		.itemId = ITEM_ROOM_2_KEY,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gRoom2KeyItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_ROOM_4_KEY] = {
		.name = _("RM. 4 KEY$"),
		.itemId = ITEM_ROOM_4_KEY,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gRoom4KeyItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_ROOM_6_KEY] = {
		.name = _("RM. 6 KEY$"),
		.itemId = ITEM_ROOM_6_KEY,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gRoom6KeyItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_STORAGE_KEY] = {
		.name = _("STORAGE KEY$"),
		.itemId = ITEM_STORAGE_KEY,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gStorageKeyItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_ROOT_FOSSIL] = {
		.name = _("ROOT FOSSIL$"),
		.itemId = ITEM_ROOT_FOSSIL,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gRootFossilItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_CLAW_FOSSIL] = {
		.name = _("CLAW FOSSIL$"),
		.itemId = ITEM_CLAW_FOSSIL,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gClawFossilItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_DEVON_SCOPE] = {
		.name = _("DEVON SCOPE$"),
		.itemId = ITEM_DEVON_SCOPE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDevonScopeItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

//TMs/HMs

	[ITEM_TM01] = {
		.name = _("TM$01"),
		.itemId = ITEM_TM01,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM01ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM02] = {
		.name = _("TM02$"),
		.itemId = ITEM_TM02,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM02ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM03] = {
		.name = _("TM03$"),
		.itemId = ITEM_TM03,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM03ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM04] = {
		.name = _("TM04$"),
		.itemId = ITEM_TM04,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM04ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM05] = {
		.name = _("TM05$"),
		.itemId = ITEM_TM05,
		.price = 1000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM05ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM06] = {
		.name = _("TM06$"),
		.itemId = ITEM_TM06,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM06ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM07] = {
		.name = _("TM07$"),
		.itemId = ITEM_TM07,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM07ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM08] = {
		.name = _("TM08$"),
		.itemId = ITEM_TM08,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM08ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM09] = {
		.name = _("TM09$"),
		.itemId = ITEM_TM09,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM09ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM10] = {
		.name = _("TM10$"),
		.itemId = ITEM_TM10,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM10ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM11] = {
		.name = _("TM11$"),
		.itemId = ITEM_TM11,
		.price = 2000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM11ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM12] = {
		.name = _("TM12$"),
		.itemId = ITEM_TM12,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM12ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM13] = {
		.name = _("TM13$"),
		.itemId = ITEM_TM13,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM13ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM14] = {
		.name = _("TM14$"),
		.itemId = ITEM_TM14,
		.price = 5500,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM14ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM15] = {
		.name = _("TM15$"),
		.itemId = ITEM_TM15,
		.price = 7500,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM15ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM16] = {
		.name = _("TM16$"),
		.itemId = ITEM_TM16,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM16ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM17] = {
		.name = _("TM17$"),
		.itemId = ITEM_TM17,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM17ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM18] = {
		.name = _("TM18$"),
		.itemId = ITEM_TM18,
		.price = 2000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM18ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM19] = {
		.name = _("TM19$"),
		.itemId = ITEM_TM19,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM19ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM20] = {
		.name = _("TM20$"),
		.itemId = ITEM_TM20,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM20ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM21] = {
		.name = _("TM21$"),
		.itemId = ITEM_TM21,
		.price = 1000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM21ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM22] = {
		.name = _("TM22$"),
		.itemId = ITEM_TM22,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM22ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM23] = {
		.name = _("TM23$"),
		.itemId = ITEM_TM23,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM23ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM24] = {
		.name = _("TM24$"),
		.itemId = ITEM_TM24,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM24ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM25] = {
		.name = _("TM25$"),
		.itemId = ITEM_TM25,
		.price = 5500,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM25ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM26] = {
		.name = _("TM26$"),
		.itemId = ITEM_TM26,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM26ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM27] = {
		.name = _("TM27$"),
		.itemId = ITEM_TM27,
		.price = 1000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM27ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM28] = {
		.name = _("TM28$"),
		.itemId = ITEM_TM28,
		.price = 2000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM28ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM29] = {
		.name = _("TM29$"),
		.itemId = ITEM_TM29,
		.price = 2000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM29ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM30] = {
		.name = _("TM30$"),
		.itemId = ITEM_TM30,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM30ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM31] = {
		.name = _("TM31$"),
		.itemId = ITEM_TM31,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM31ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM32] = {
		.name = _("TM32$"),
		.itemId = ITEM_TM32,
		.price = 2000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM32ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM33] = {
		.name = _("TM33$"),
		.itemId = ITEM_TM33,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM33ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM34] = {
		.name = _("TM34$"),
		.itemId = ITEM_TM34,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM34ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM35] = {
		.name = _("TM35$"),
		.itemId = ITEM_TM35,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM35ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM36] = {
		.name = _("TM36$"),
		.itemId = ITEM_TM36,
		.price = 1000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM36ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM37] = {
		.name = _("TM37$"),
		.itemId = ITEM_TM37,
		.price = 2000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM37ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM38] = {
		.name = _("TM38$"),
		.itemId = ITEM_TM38,
		.price = 5500,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM38ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM39] = {
		.name = _("TM39$"),
		.itemId = ITEM_TM39,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM39ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM40] = {
		.name = _("TM40$"),
		.itemId = ITEM_TM40,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM40ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM41] = {
		.name = _("TM41$"),
		.itemId = ITEM_TM41,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM41ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM42] = {
		.name = _("TM42$"),
		.itemId = ITEM_TM42,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM42ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM43] = {
		.name = _("TM43$"),
		.itemId = ITEM_TM43,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM43ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM44] = {
		.name = _("TM44$"),
		.itemId = ITEM_TM44,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM44ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM45] = {
		.name = _("TM45$"),
		.itemId = ITEM_TM45,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM45ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM46] = {
		.name = _("TM46$"),
		.itemId = ITEM_TM46,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM46ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM47] = {
		.name = _("TM47$"),
		.itemId = ITEM_TM47,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM47ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM48] = {
		.name = _("TM48$"),
		.itemId = ITEM_TM48,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM48ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM49] = {
		.name = _("TM49$"),
		.itemId = ITEM_TM49,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM49ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM50] = {
		.name = _("TM50$"),
		.itemId = ITEM_TM50,
		.price = 3000,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTM50ItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_HM01] = {
		.name = _("HM01$"),
		.itemId = ITEM_HM01,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gHM01ItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_HM02] = {
		.name = _("HM02$"),
		.itemId = ITEM_HM02,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gHM02ItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_HM03] = {
		.name = _("HM03$"),
		.itemId = ITEM_HM03,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gHM03ItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_HM04] = {
		.name = _("HM04$"),
		.itemId = ITEM_HM04,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gHM04ItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_HM05] = {
		.name = _("HM05$"),
		.itemId = ITEM_HM05,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gHM05ItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_HM06] = {
		.name = _("HM06$"),
		.itemId = ITEM_HM06,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gHM06ItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_HM07] = {
		.name = _("HM07$"),
		.itemId = ITEM_HM07,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gHM07ItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_HM08] = {
		.name = _("HM08$"),
		.itemId = ITEM_HM08,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gHM08ItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_TM_HM,
		.type = 1,
		.fieldUseFunc = ItemUseOutOfBattle_TMHM,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

//Empty items

	[ITEM_15B] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_15C] = {
		.name = _("????????$"),
		.itemId = ITEM_NONE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDummyItemDescription,
		.importance = 0,
		.unk19 = 0,
		.pocket = POCKET_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

//FireRed/LeafGreen key items

	[ITEM_OAKS_PARCEL] = {
		.name = _("OAK’S PARCEL$"),
		.itemId = ITEM_OAKS_PARCEL,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gOaksParcelItemDescription,
		.importance = 2,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_POKE_FLUTE] = {
		.name = _("POKé FLUTE$"),
		.itemId = ITEM_POKE_FLUTE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gPokeFluteItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_SECRET_KEY] = {
		.name = _("SECRET KEY$"),
		.itemId = ITEM_SECRET_KEY,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gSecretKeyItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_BIKE_VOUCHER] = {
		.name = _("BIKE VOUCHER$"),
		.itemId = ITEM_BIKE_VOUCHER,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gBikeVoucherItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_GOLD_TEETH] = {
		.name = _("GOLD TEETH$"),
		.itemId = ITEM_GOLD_TEETH,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gGoldTeethItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_OLD_AMBER] = {
		.name = _("OLD AMBER$"),
		.itemId = ITEM_OLD_AMBER,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gOldAmberItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_CARD_KEY] = {
		.name = _("CARD KEY$"),
		.itemId = ITEM_CARD_KEY,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gCardKeyItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_LIFT_KEY] = {
		.name = _("LIFT KEY$"),
		.itemId = ITEM_LIFT_KEY,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gLiftKeyItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_HELIX_FOSSIL] = {
		.name = _("HELIX FOSSIL$"),
		.itemId = ITEM_HELIX_FOSSIL,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gHelixFossilItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_DOME_FOSSIL] = {
		.name = _("DOME FOSSIL$"),
		.itemId = ITEM_DOME_FOSSIL,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gDomeFossilItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_SILPH_SCOPE] = {
		.name = _("SILPH SCOPE$"),
		.itemId = ITEM_SILPH_SCOPE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gSilphScopeItemDescription,
		.importance = 1,
		.unk19 = 0,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_BICYCLE] = {
		.name = _("BICYCLE$"),
		.itemId = ITEM_BICYCLE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gBicycleItemDescription,
		.importance = 1,
		.unk19 = 1,
		.pocket = POCKET_KEY_ITEMS,
		.type = 2,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TOWN_MAP] = {
		.name = _("TOWN MAP$"),
		.itemId = ITEM_TOWN_MAP,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTownMapItemDescription,
		.importance = 1,
		.unk19 = 1,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_VS_SEEKER] = {
		.name = _("VS SEEKER$"),
		.itemId = ITEM_VS_SEEKER,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gVSSeekerItemDescription,
		.importance = 1,
		.unk19 = 1,
		.pocket = POCKET_KEY_ITEMS,
		.type = 2,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_FAME_CHECKER] = {
		.name = _("FAME CHECKER$"),
		.itemId = ITEM_FAME_CHECKER,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gFameCheckerItemDescription,
		.importance = 1,
		.unk19 = 1,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TM_CASE] = {
		.name = _("TM CASE$"),
		.itemId = ITEM_TM_CASE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTMCaseItemDescription,
		.importance = 1,
		.unk19 = 1,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_BERRY_POUCH] = {
		.name = _("BERRY POUCH$"),
		.itemId = ITEM_BERRY_POUCH,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gBerryPouchItemDescription,
		.importance = 1,
		.unk19 = 1,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TEACHY_TV] = {
		.name = _("TEACHY TV$"),
		.itemId = ITEM_TEACHY_TV,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTeachyTVItemDescription,
		.importance = 1,
		.unk19 = 1,
		.pocket = POCKET_KEY_ITEMS,
		.type = 2,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TRI_PASS] = {
		.name = _("TRI-PASS$"),
		.itemId = ITEM_TRI_PASS,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTriPassItemDescription,
		.importance = 1,
		.unk19 = 4,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_RAINBOW_PASS] = {
		.name = _("RAINBOW PASS$"),
		.itemId = ITEM_RAINBOW_PASS,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gRainbowPassItemDescription,
		.importance = 1,
		.unk19 = 1,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_TEA] = {
		.name = _("TEA$"),
		.itemId = ITEM_TEA,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gTeaItemDescription,
		.importance = 1,
		.unk19 = 1,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_MYSTIC_TICKET] = {
		.name = _("MYSTICTICKET$"),
		.itemId = ITEM_MYSTIC_TICKET,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gMysticTicketItemDescription,
		.importance = 1,
		.unk19 = 1,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_AURORA_TICKET] = {
		.name = _("AURORATICKET$"),
		.itemId = ITEM_AURORA_TICKET,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gAuroraTicketItemDescription,
		.importance = 1,
		.unk19 = 1,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_POWDER_JAR] = {
		.name = _("POWDER JAR$"),
		.itemId = ITEM_POWDER_JAR,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gPowderJarItemDescription,
		.importance = 1,
		.unk19 = 1,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_PowderJar,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_RUBY] = {
		.name = _("RUBY$"),
		.itemId = ITEM_RUBY,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gRubyItemDescription,
		.importance = 1,
		.unk19 = 1,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_SAPPHIRE] = {
		.name = _("SAPPHIRE$"),
		.itemId = ITEM_SAPPHIRE,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gSapphireItemDescription,
		.importance = 1,
		.unk19 = 1,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

//Emerald-specific key items

	[ITEM_MAGMA_EMBLEM] = {
		.name = _("MAGMA EMBLEM$"),
		.itemId = ITEM_MAGMA_EMBLEM,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gMagmaEmblemItemDescription,
		.importance = 1,
		.unk19 = 1,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

	[ITEM_OLD_SEA_MAP] = {
		.name = _("OLD SEA MAP$"),
		.itemId = ITEM_OLD_SEA_MAP,
		.price = 0,
		.holdEffect = 0,
		.holdEffectParam = 0,
		.description = gOldSeaMapItemDescription,
		.importance = 1,
		.unk19 = 1,
		.pocket = POCKET_KEY_ITEMS,
		.type = 4,
		.fieldUseFunc = ItemUseOutOfBattle_CannotUse,
		.battleUsage = 0,
		.battleUseFunc = NULL,
		.secondaryId = 0,
	},

};
